Ext.BLANK_IMAGE_URL = "../../widgets/ext-2.2.1/resources/images/default/s.gif";
Ext.QuickTips.init();
Ext.form.Field.prototype.msgTarget = 'under';

Ext.namespace('com.awd');
Ext.namespace('com.awd.advancedSearch');

/**
 * 自定义条件选择时，可选择的表名称
 * @type 
 */
var baseTableData = [];
var TABLECOLUMNS = "";
var expressIndex = 6;

com.awd.advancedSearch.selectorWin = Ext.extend(Ext.Window,{
	initComponent:function() {
		Ext.apply(this,{
	        title:'定义查询结果列',
	        width:650,
	        height:395,
	        modal:true,
	        closeAction:'hide',
	        layout:'fit'
	    });
		com.awd.advancedSearch.selectorWin.superclass.initComponent.call(this);
	}
});


/**
 * 组合条件列表
 * @class com.awd.advancedSearchEditorGrid
 * @extends Ext.grid.EditorGridPanel
 */
com.awd.advancedSearchEditorGrid = Ext.extend(Ext.grid.EditorGridPanel,{
	id:'searchEditorGridId',
	initComponent:function() {
        this.pageSize=50;
        this.ds = new Ext.data.Store({
            url:'',
            reader:new Ext.data.JsonReader({
                }
                ,['fieldname','relationsign','expressvalue','operatorsign','tablename','rightbrackets','leftbrackets','expressvaluestring','tablenamestring','fieldnamestring','name']
            ),
            pruneModifiedRecords: true
        });
        
        this.rowActions = new Ext.ux.grid.RowActions({
			id:'actions' 
			,header:'操作'
			,widthIntercept:Ext.isSafari ? 4 : 2 
			,actions:[{iconCls:'icon-top',qtip:'移至顶部'}
					   ,{iconCls:'icon-up',qtip:'向上移动一行' }
					   ,{iconCls:'icon-down',qtip:'向下移动一行' }
					   ,{iconCls:'icon-bottom',qtip:'移至底部' }
					   ,{iconCls:'deleteicon',qtip:'删除当前行'}
					] 
		});
		
		this.rowActions.on('action', this.onRowAction, this); 
       
        var operatorSignComboData = [['0','并且'],['1','或者'],['','无']];
        var leftBracketsComboData = [['','无'],['1','(']];
        var rightBracketsComboData = [['','无'],['1',')']];
    
        var relationSignComboData = [['0','大于'],['1','大于等于'],['2','等于'],['3','不等于'],['4','小于'],['5','小于等于'],['6','包含'],['7','为空'],['8','不为空']];
    
        this.sm = new Ext.grid.CheckboxSelectionModel();
        this.cm = new Ext.grid.ColumnModel([
            new Ext.grid.RowNumberer(),
            this.sm,
             {header:'括号',dataIndex:'leftbrackets',width:40,editor:new Ext.grid.GridEditor(new Ext.form.ComboBox({
                    store: new Ext.data.SimpleStore({
                        fields:['value','text'],
                        data: leftBracketsComboData
                    }),
                    mode: 'local',
                    triggerAction: 'all',
                    editable:false,
                    valueField: 'value',
                    displayField: 'text',
                    readOnly:true
//                    lazyInit:false,
//					listeners: {
//						'focus' : 
//      						function(){  
//							    this.expand();  
//						   	}  
//          			}
                })),
                renderer: function(value, cellmeta, record){
                    if(value == null || value == ""){
                        return "";
                    }
                    return leftBracketsComboData[value][1];
                },scope:this}
            ,{header:'表名称',dataIndex:'tablename',width:80,editor:new Ext.grid.GridEditor(new Ext.form.ComboBox({
                    store: new Ext.data.SimpleStore({
                        fields:['value','text'],
                        data: baseTableData
                    }),
                    id:'baseTableNameID',
                    tpl: '<tpl for="."><div ext:qtip="{text}" class="x-combo-list-item">{text}</div></tpl>',
                    mode: 'local',
                    triggerAction: 'all',
                  	editable:false,
                    valueField: 'value',
                    displayField: 'text',
                    lazyInit:false,
					listeners: {
						 'expand':function(combo){
      							combo.clearValue();
      							combo.store.loadData(baseTableData);
					 	 }
					 	 ,'select':function(){
					 	 		
					 	 }
						 ,'focus' :function(){  
							    this.expand();  
				   		}  
          			}
                })),
                renderer: function(value, cellmeta, record, row, col, store){
               		if(value == null || value == ""){
                        return;
                    } 
                    return record.get("tablenamestring");
                }}
            ,{header:'查询条件列',dataIndex:'fieldname',width:90,editor:new Ext.grid.GridEditor(new Ext.form.ComboBox({
                    id:'fieldnameID'
	              	,store : new Ext.data.Store({
								proxy : new Ext.data.HttpProxy({url : '../SearchTableColumns/extlistKV.do'})
								,reader : new Ext.data.JsonReader({}, ['name','chinese'])
								,baseParams:{s_tablename:'0'}
								})   
							,tpl: '<tpl for="."><div ext:qtip="{chinese}" class="x-combo-list-item">{chinese}</div></tpl>'
							,valueField :'name'
							,displayField :'chinese'
							,mode : 'remote'
							,forceSelection : true
							,triggerAction : 'all'
							,typeAhead : false
							,selectOnFocus : true
							,resizable:true
							,width : 120
							,lazyInit:false
							,listeners: {
	  							'focus' : 
	          						function(){  
									    this.expand();  
								   	}
	          				}
					}
                )),
                renderer: function(value, cellmeta, record, row, col, store){
                    if(value == null || value == ""){
                        return "";
                    }
                    return record.get("fieldnamestring");
                }}
            ,{header:'逻辑运算符',dataIndex:'relationsign',width:70,editor:new Ext.grid.GridEditor(new Ext.form.ComboBox({
                    store: new Ext.data.SimpleStore({
                        fields:['value','text'],
                        data: relationSignComboData
                    }),
                    mode: 'local',
                    triggerAction: 'all',
                    editable:false,
                    valueField: 'value',
                    displayField: 'text',
                    readOnly:true,
                    lazyInit:false,
					listeners: {
						 'focus' : 
      						function(){  
							    this.expand();  
						   	}  
          			}
                })),
                renderer: function(value, cellmeta, record, row, col, store){
                    if(value == null || value == ""){
                        return;
                    }
                    return relationSignComboData[value][1];
                },scope:this}
        	,{header:'查询条件值',dataIndex:'expressvalue',width:125,editor:new Ext.grid.GridEditor(new Ext.form.TextField({       }))
               , renderer: function(value, cellmeta, record, row, col, store){
                    if(value == null || value == ""){
                        return "";
                    }
                    return record.get("expressvaluestring");
                }
                }
                ,{header:'括号',dataIndex:'rightbrackets',width:40,editor:new Ext.grid.GridEditor(new Ext.form.ComboBox({
                    store: new Ext.data.SimpleStore({
                        fields:['value','text'],
                        data: rightBracketsComboData
                    }),
                    mode: 'local',
                    triggerAction: 'all',
                    editable:false,
                    valueField: 'value',
                    displayField: 'text',
                    readOnly:true,
                    lazyInit:false,
					listeners: {
						 'focus' : 
      						function(){  
							    this.expand();  
						   	}  
          			}
                })),
                renderer: function(value, cellmeta, record){
                    if(value == null || value == ""){
                        return "";
                    }
                    return rightBracketsComboData[value][1];
                },scope:this}
               ,{header:'关系运算符',dataIndex:'operatorsign',width:70,editor:new Ext.grid.GridEditor(new Ext.form.ComboBox({
                    store: new Ext.data.SimpleStore({
                        fields:['value','text'],
                        data: operatorSignComboData
                    }),
                    mode: 'local',
                    triggerAction: 'all',
                    editable:false,
                    valueField: 'value',
                    displayField: 'text',
                    readOnly:true,
                    lazyInit:false,
					listeners: {
						 'focus' : 
      						function(){  
							    this.expand();  
						   	}  
          			}
                })),
                renderer: function(value, cellmeta, record){
                    if(value == null || value == ""){
                        return ;
                    }
                    return operatorSignComboData[value][1];
                },scope:this}
                ,this.rowActions
               
        ]);
        
        /**
         * 扩展类的构建开始
         */
        Ext.apply(this,{
            store:this.ds
            ,plugins : [this.rowActions]
            ,sm:this.sm
            ,cm: this.cm
            ,border:false
            ,clicksToEdit:1
            ,stripeRows: true 			//隔行变色，区分表格行  
            ,collapsible: true 			//是否在右上角显示收缩按钮  
            ,animCollapse: true 		//表示收缩（闭合）面板时，显示动画效果  
            ,trackMouseOver: true 		//鼠标在行上移动时显示高亮  
            ,enableColumnMove: false	//禁止用户拖动表头  
            ,tbar:[ 
  		   		 	{xtype:'label',html:'&nbsp;主表名称:&nbsp;',id:'mainTableLabelId'}
				    ,{xtype : 'combo',name:'mainTableName',id:'mainTableNameId'
							,store : new Ext.data.Store({
								proxy : new Ext.data.HttpProxy({url : '../SearchTables/extlistKV.do'})
								,reader : new Ext.data.JsonReader({}, ['name','chinese','hasson'])
								,baseParams:{s_parentid:'0'}
								})   
							,valueField :'name'
							,displayField :'chinese'
							,tpl: '<tpl for="."><div ext:qtip="{chinese}" class="x-combo-list-item">{chinese}</div></tpl>'
							,mode : 'remote'
							,forceSelection : true
							,triggerAction : 'all'
							,typeAhead : false
							,selectOnFocus : true
							,resizable:true
							,width : 130
							,lazyInit:false
							,listeners: {
	          					'select':
	          						function(combo,record,index){
	          							/**获取从表选择的组件*/
	          							var minorTableName = Ext.getCmp("minorTableNameId");
	          							var minorTableLabel = Ext.getCmp("minorTableLabelId");
	          							
	          							/**
	          							 * 判断是否有从表
	          							 */
	          							if (record.get("hasson") == "1"){	//有从表
	          								var conditionGridStore = Ext.getCmp("searchEditorGridId").getStore();
	          								var storeCount  = conditionGridStore.getCount();
	          								if (storeCount>0){
		          								Ext.Msg.alert("提示","主表发生变化，请删除列表中的查询条件后，再重新选择");
		          								combo.setValue(baseTableData[0][0]);
		          								combo.setRawValue(baseTableData[0][1]);
		          								return;
	          								}
	          								minorTableLabel.enable();  
			   								minorTableLabel.show();   			
											minorTableName.enable();  
			   								minorTableName.show();
	          							} else {							//无从表
	          								minorTableLabel.disable();  
			   								minorTableLabel.hide();   			
											minorTableName.disable();  
			   								minorTableName.hide(); 
	          							}
	          							
	          							/**
	          							 * 初始化表名称数组，供用户添加查询条件时的选择
	          							 */
	          							if(Ext.isEmpty(baseTableData) 
	          								|| baseTableData.length == 0){	
		          							baseTableData = [[combo.getValue(),combo.getRawValue()]];
		          							if (record.get("hasson") == "1"){
			          							/**
			          							 * 当重新选择或者改变主表时，同时更新从表的Store并情况现有的数据
			          							 */
			          							minorTableName.getStore().baseParams['s_parentid'] = combo.getValue();
			          							minorTableName.getStore().reload();
			          							minorTableName.clearValue();
		          							}
	          							} else if(baseTableData[0][0] != combo.getValue()){	
	          								/**
	          								 * 获取查询条件列表的记录数
	          								 */
	          								var conditionGridStore = Ext.getCmp("searchEditorGridId").getStore();
	          								var storeCount  = conditionGridStore.getCount();
	          								if (storeCount>0){
		          								Ext.Msg.alert("提示","主表发生变化，请删除列表中的查询条件后，再重新选择");
		          								combo.setValue(baseTableData[0][0]);
		          								combo.setRawValue(baseTableData[0][1]);
		          								return;
	          								} else {
	          									baseTableData = [[combo.getValue(),combo.getRawValue()]];
			          							if (record.get("hasson") == "1"){
		          									/**
				          							 * 当重新选择或者改变主表时，同时更新从表的Store并情况现有的数据
				          							 */
				          							minorTableName.getStore().baseParams['s_parentid'] = combo.getValue();
				          							minorTableName.getStore().reload();
				          							minorTableName.clearValue();
			          							}
	          								}
	          							}
	          						}
	  							,'focus' : 
	          						function(){  
									    this.expand();  
								   	}
	          				}
					} 
			        ,{xtype:'label',html:'&nbsp;&nbsp;从表名称:&nbsp;&nbsp;',id:'minorTableLabelId'}
				    ,{xtype : 'combo',name:'minorTableName',id:'minorTableNameId'
							,store : new Ext.data.Store({
								proxy : new Ext.data.HttpProxy({url : '../SearchTables/extlistKV.do'})
								,reader : new Ext.data.JsonReader({}, ['name','chinese'])
								,baseParams:{s_parentid:'1'}
								})   
							,valueField :'name'
							,displayField :'chinese'
							,tpl: '<tpl for="."><div ext:qtip="{chinese}" class="x-combo-list-item">{chinese}</div></tpl>'
							,mode : 'remote'
							,forceSelection : true
							,triggerAction : 'all'
							,lazyInit:false
							,typeAhead : false
							,selectOnFocus : true
							,resizable:true
							,width : 130
							,bbar:[{xtype:'button',text:'重置',handler:function(){
								var conditionGridStore = Ext.getCmp("searchEditorGridId").getStore();
								var storeCount  = conditionGridStore.getCount();
  								if (storeCount > 0) {
  									Ext.Msg.alert("提示","有查询条件列，无法清空");
  								}else{
          							var minorTableName = Ext.getCmp("minorTableNameId");
          							minorTableName.clearValue();
          							minorTableName.collapse() ;
          							baseTableData[1][0] = null;
          							baseTableData[1][1] = null;
  								}
							},scope:this}]
							,listeners: {
	          					'select':
	          						function(combo,record,index){
	          							/**
	          							 * 从表的选择 undefined
	          							 */
	          							if (Ext.isEmpty(baseTableData) 
	          								|| baseTableData.length == 0 ){	//基本表数组为空
	          								Ext.Msg.alert("提示","请先选择待查询的主表");
	          								return;
	          							} else if(baseTableData.length == 1){
		          							baseTableData.push([combo.getValue(),combo.getRawValue()]) ;	
	          							} else if(baseTableData.length == 2 
	          									&& baseTableData.toString().indexOf(combo.getValue()) == -1){
	      									/**
	          								 * 获取查询条件列表的记录数
	          								 */
	          								var conditionGridStore = Ext.getCmp("searchEditorGridId").getStore();
	          								var storeCount  = conditionGridStore.getCount();
	          								if (storeCount > 0) {
												Ext.Msg.alert("提示",
														"从表发生变化，请删除列表中的查询条件后,再重新选择");
												combo.setValue(baseTableData[1][0]);
		          								combo.setRawValue(baseTableData[1][1]);
												return false;
											} else {
												baseTableData[1] = [combo.getValue(),
														combo.getRawValue()];
											}
	          							}
	          						}
	          					,'focus' : 
	          						function(){  
									    this.expand();  
								   	}  
	          				}
					}
					,'->'
	                ,{text: '添加条件',cls:'x-btn-text-icon',iconCls:'addicon',handler: this.insertRow, scope:this}, '-'
	                ,{text: '删除条件',cls:'x-btn-text-icon',iconCls:'deleteicon',handler: this.deleteRows,scope:this}
	                ]
                ,bbar:["保存为个人搜索器&nbsp;:&nbsp;",{xtype:'textfield',name:'searchName',id:'searchNameId'},'&nbsp;&nbsp;'
                	,{text:'保存',cls:'x-btn-text-icon',iconCls:'editicon',handler:this.saveFinder,scope:this}
                	,'->'
                	,{text:'定义查询结果显示列',cls:'x-btn-text-icon',iconCls:'chooseicon',handler:this.openTableFieldSelectorWin,scope:this}
                	,'-',{text:'查询检索',cls:'x-btn-text-icon',iconCls:'queryicon',handler:this.search,scope:this}
                	]
//              ,viewConfig : {   
//				    layout : function() {   
//				        if (!this.mainBody) {   
//				            return; // not rendered   
//				        }   
//				        var g = this.grid;   
//				        var c = g.getGridEl();   
//				        var csize = c.getSize(true);   
//				        var vw = csize.width;   
//				        if (!g.hideHeaders && (vw < 20 || csize.height < 20)) { // display:   
//				            // none?   
//				            return;   
//				        }   
//				        if (g.autoHeight) {   
//				            if (this.innerHd) {   
//				                this.innerHd.style.width = (vw) + 'px';   
//				            }   
//				        } else {   
//				            this.el.setSize(csize.width, csize.height);   
//				            var hdHeight = this.mainHd.getHeight();   
//				            var vh = csize.height - (hdHeight);   
//				            this.scroller.setSize(vw, vh);   
//				            if (this.innerHd) {   
//				                this.innerHd.style.width = (vw) + 'px';   
//				            }   
//				        }   
//				        if (this.forceFit) {   
//				            if (this.lastViewWidth != vw) {   
//				                this.fitColumns(false, false);   
//				                this.lastViewWidth = vw;   
//				            }   
//				        } else {   
//				            this.autoExpand();   
//				            this.syncHeaderScroll();   
//				        }   
//				        this.onLayout(vw, vh);   
//				    }   
//				}
        });
        com.awd.advancedSearchEditorGrid.superclass.initComponent.call(this);
        
		this.tableFieldSelector = new com.awd.advancedSearch.tableFieldSelector
		this.tableFieldSelectorWin =  new com.awd.advancedSearch.selectorWin({
			items:this.tableFieldSelector
			,buttons:[{
		            text:'确定',
		            handler:function(){ 
			            	this.tableFieldSelectorWin.hide();
			            	TABLECOLUMNS = this.getSelectedTableColums();
	            		} 
		           , scope:this
		        }]
	    });
	    
        this.on({"cellclick":this.cellclick});
        this.on("afteredit",this.afterGridEdit);
    }
    ,saveFinder:function(){
    	var rsl = this.getSearchConditonInfo();
    	if (Ext.isEmpty(rsl) || rsl.length < 3) {
			Ext.Msg.alert("提示", "请先增加查询条件");
			return;
		}
		var tableColumns = TABLECOLUMNS;

		if(Ext.isEmpty(tableColumns)){
			Ext.Msg.alert("提示","请先选择查询结果显示列");
			return;
		}
		
		var searchName = Ext.getCmp("searchNameId").getValue();
		
		if(Ext.isEmpty(searchName)){
			Ext.Msg.alert("提示","搜索器名称为空");
			return;
		}
		
		Ext.Ajax.request({
			url:'../AdvancedSearch/extSaveFinder.do',
            method:'POST',   
            params:{'searchCondition':rsl,'tables':baseTableData.toString(),'tableColums':tableColumns,'searchName':searchName},
            success:function(response){
                var data = Ext.util.JSON.decode(response.responseText);
                if (data.success == true){
                	Ext.Msg.alert("提示",searchName + "搜索器保存成功!");
		          	this.fireEvent("reloadSsqTree",null);
                } else {
                    Ext.MessageBox.alert('警告',data.msg);
                } 
            },
            scope:this,
            failure:function(form,action){
	            Ext.MessageBox.alert('警告',action.result.msg);
	        }
        });
    }
	,openTableFieldSelectorWin:function(){
		if(Ext.isEmpty(baseTableData) 
					|| baseTableData.length == 0){
			Ext.Msg.alert("提示","请先选择待查询表");
			return;		
		}  
		this.tableFieldSelectorWin.setSize(720,480);
		this.tableFieldSelectorWin.setTitle("定义查询结果列");
		this.tableFieldSelectorWin.show();
		try{
			this.tableFieldSelectorWin.items.itemAt(0).items.itemAt(0).loadTableField(TABLECOLUMNS);
		}catch (ex){
		}
		
	}
    ,afterGridEdit:function(obj){
    	var column = obj.column;
    	var record = obj.record ; 
    	var cm = obj.grid.getColumnModel();
        var field = cm.getCellEditor(column).field;
        
    	switch(column) { 
			case 3:
	            if(obj.value != obj.originalValue){	//如果新旧值不一致，则清空该记录的所有值，除了表名称
	            	record.set("fieldname","");
	            	record.set("fieldnamestring","");
	            	record.set("relationsign","");
	            	record.set("expressvalue","");
	            	record.set("expressvaluestring","");
	            	record.set("rightbrackets","");
	            	record.set("leftbrackets","");
	            	record.set("operatorsign","");
	            	record.set("name","");
	            }
				record.set("tablenamestring",Ext.getCmp("baseTableNameID").getRawValue());
				break;
			case 4:
				if(obj.value != obj.originalValue){	//如果新旧值不一致，则清空查询条件值
					record.set("expressvalue","");
	            	record.set("expressvaluestring","");
				}
				record.set("fieldnamestring",Ext.getCmp("fieldnameID").getRawValue());
				record.set("name",obj.value.split("|")[0]);
				break;
			case 5:
				break;
			case 6:
				record.set("expressvaluestring",field.getRawValue());
				break;
    	}
    }
    /**
     * 执行 上移，下移 删除等操作的事件方法
     * @param {} grid
     * @param {} record
     * @param {} action
     * @param {} row
     * @param {} col
     */
    ,onRowAction:function(grid, record, action, row, col) {
    	var store = grid.getStore();
		switch(action) { 
			case 'icon-top':
				if (row > 0) {
					store.removeAt(row);
					store.insert(0, record);
					grid.getSelectionModel().selectRow(0);
					grid.getView().refresh();
				}
				break; 
			case 'icon-up': 
				if (row > 0) {
					store.removeAt(row);
					store.insert(row - 1, record);
					grid.getSelectionModel().selectRow(row - 1);
					grid.getView().refresh();
				}
				break; 
			case 'icon-down': 
				if (row < store.getCount() - 1) {
					store.removeAt(row);
					store.insert(row + 1, record);
					grid.getSelectionModel().selectRow(row + 1);
					grid.getView().refresh();
				}
				break; 
			case 'icon-bottom': 
				var count = store.getCount();
				if (row < count - 1) {
					store.removeAt(row);
					store.insert(count - 1, record);
					grid.getSelectionModel().selectRow(count - 1);
					grid.getView().refresh();
				}
				break; 
			case 'deleteicon': 
                store.remove(record);
                grid.getView().refresh();
				break; 
		}
	}
    ,cellclick:function(grid,rowIndex,columnIndex,e){ 
    	var record = grid.getStore().getAt(rowIndex);
		if (record == undefined) {
			return;
		}
		var tableName = record.get("tablename");
        var fieldname = record.get("fieldname");

        switch(columnIndex) { 
			case 4:			//字段列
				if(Ext.isEmpty(tableName)){
					Ext.Msg.alert("提示","请先选择表名称");
				}else{
					var fieldnameStore = Ext.getCmp("fieldnameID").getStore();
			 		fieldnameStore.baseParams['s_tablename'] = tableName;
			 		fieldnameStore.reload();
				}
				break;
			case 5:
				break;
			case 6:			//查询条件值
				if(Ext.isEmpty(fieldname)){
					Ext.Msg.alert("提示","请先选择查询条件列");
//					grid.stopEditing();
//					grid.startEditing(columnIndex,4);
					return;
				}
				if (record.get("relationsign") == "7"
						|| record.get("relationsign") == "8") {
					Ext.Msg.alert("提示", "不允许编辑该行");
					break;
				}
				this.generateWidget(grid,fieldname,columnIndex);
				break;
        }
    }   
    //动态生成字段，字段名称包含了字段的名称及类型，以“|”分割
    ,generateWidget:function(grid,fieldname,columnIndex){
        if(Ext.isEmpty(fieldname)){
            return;
        }
        var arr = fieldname.split("|");
        var xtype = arr[1];
        
        var cm = grid.getColumnModel();
        var field = cm.getCellEditor(columnIndex).field;
        
        if(field != null){
            field.destroy();
        }
        
        
        switch(xtype) { 
			case 'textfield':
				this.getColumnModel().setEditor(expressIndex,new Ext.grid.GridEditor(new Ext.form.TextField({
	           })));
				break;
        	case 'datefield':
	            this.getColumnModel().setEditor(expressIndex,new Ext.grid.GridEditor(new Ext.form.DateField({
	                    format:'Y-m-d' })));
        		break;
        	case 'datetime':
	            this.getColumnModel().setEditor(expressIndex,new Ext.grid.GridEditor(new Ext.form.DateField({
	                    format:'Y-m-d H:i:s' ,menu:new DatetimeMenu(),value:""})));
        		break;
        	case 'cbo':
				this.setCombo(arr[2]);
        		break;
        	case 'cbozd':
				this.setComboZD(arr[2]);
        		break;
        	case 'cbocontent':
	            this.setComboZDAsContent(arr[2]);
        		break;
        	case '':
        		this.getColumnModel().setEditor(expressIndex,new Ext.grid.GridEditor(new Ext.form.TextField({
	                value:""
	           })));
				break; 
        }
    }
    //动态生成字典列表选择 
    ,setCombo:function(fieldtype){
        this.getColumnModel().setEditor(expressIndex,new Ext.grid.GridEditor(new Ext.ux.CommonComboFY({
            url:'../../pages/Xxdm/extlistKV_Pagination.do?field_type='+fieldtype,pageSize:10
			,tpl: '<tpl for="."><div ext:qtip="{content}" class="x-combo-list-item">{content}</div></tpl>'
        })));
    }
    ,setComboZD:function(fieldtype){
        this.getColumnModel().setEditor(expressIndex,new Ext.grid.GridEditor(new Ext.ux.CommonComboZDFY({
                url:'../../pages/ZdGlobal/extlistKV_Pagination.do?field_type='+fieldtype,pageSize:10
				,tpl: '<tpl for="."><div ext:qtip="{kvalue}" class="x-combo-list-item">{kvalue}</div></tpl>'
        })));
    }
    ,setComboZDAsContent:function(fieldtype){
        this.getColumnModel().setEditor(expressIndex,new Ext.grid.GridEditor(new Ext.ux.CommonComboZDFY({
                url:'../../pages/ZdGlobal/extlistKV_Pagination.do?field_type='+fieldtype,pageSize:10,valueField:'kvalue',gForceSelection:false
				,tpl: '<tpl for="."><div ext:qtip="{kvalue}" class="x-combo-list-item">{kvalue}</div></tpl>'
        })));
    }
    ,insertRow:function(){
		if(baseTableData.length == 0){
			Ext.Msg.alert("提示","请先选择待查询的表");
			return;
		}
    	var initValue = {leftbrackets:'',tablename:baseTableData[0][0],tablenamestring:baseTableData[0][1],fieldname:'',relationsign:'',expressvalue:'',rightbrackets:'',operatorsign:''};

         var Record = Ext.data.Record.create([ 
            {name: 'fieldname', type: 'string'},
            {name: 'relationsign', type: 'string'},
            {name: 'expressvalue', type: 'string'},
            {name: 'operatorsign', type: 'string'},
            {name: 'tablename', type: 'string'},
            {name: 'rightbrackets', type: 'string'},
            {name: 'leftbrackets', type: 'string'},
            {name: 'expressvaluestring', type: 'string'},
            {name: 'tablenamestring', type: 'string'},
            {name: 'fieldnamestring', type: 'string'},
            {name: 'name', type: 'string'} 				//字段名例如入所日期 -> RSRQ
        ]);
        var p = new Record(initValue);

        this.stopEditing();
        
        this.getStore().insert(this.getStore().getCount(), p);
        this.startEditing(this.getStore().getCount()-1,2);

        p.dirty = true;
        p.modified = initValue;
        if(this.getStore().modified.indexOf(p) == -1){
            this.getStore().modified.push(p);
        }
    }
    ,deleteRows:function(){
            var records = this.getSelectionModel().getSelections();
            if (!records||records.length == 0) {
                Ext.Msg.alert("提示", "请先选择要删除的记录！");
                return;
            }      
            
            var ds = this.getStore();
            var view = this.getView();
            
            Ext.Msg.confirm('提示', '确定要删除吗？', function(btn){
                if (btn != 'yes') {
                    return;
                }
                for(var i = 0; i < records.length; i++) {
                    ds.remove(records[i]);
//                    view.refresh();
                }
            });
    }
    ,getSearchConditonInfo:function(){
    	
        var ds = this.getStore();
        var cm = this.getColumnModel();
//        var m = ds.modified.slice(0);
//        var m = ds.get;
        var mLength = ds.getCount();
        var fLength = 0;
        var record = null;
        var fields = null;
        var name = null;
        var value = null;
        var colIndex = null;
        var rowIndex = null;
        var editor = null;
        
        for (var i = 0; i < mLength; i++) {
            record = ds.getAt(i);
            fields = record.fields.keys;
            fLength = fields.length;

            for (var j = 0; j < fLength; j++) {
                name = fields[j];
                //忽略左右括号值的判断
	            if (name == "rightbrackets" 
	            	|| name == "leftbrackets"
	            	|| name == "expressvaluestring"
	            	|| name == "tablenamestring"
	            	|| name == "fieldnamestring"
	            	|| name == "name"
	            	) {
					continue;
				}
				
                value = record.data[name];
                colIndex = cm.findColumnIndex(name);
                rowIndex = ds.indexOfId(record.id);
//                cm.getCellEditor(colIndex).field.reset();
//                editor = cm.getCellEditor(colIndex).field;
                
                //校验数据的准确性
//                if (value == null || value == ""
//						|| !editor.validateValue(value)) {
                if (value == null || value == "") {
					if (name == "expressvalue"
							&& (record.data["relationsign"] == "7" 
							  || record.data["relationsign"] == "8")) {  //逻辑运算符是 为空，不为空
					} else if(mLength == (i+1) && name == "operatorsign"){	 //忽略最后一个条件的关系运算符	
					} else {
						this.startEditing(rowIndex, colIndex);
						return;
					}
				}
            }
        }
        
        var jsonArray = [];
        ds.each(function(rec) {
			jsonArray.push(rec.data);
		},this);  
 
        return Ext.encode(jsonArray);
    }
    ,search:function(){
    	var rsl = this.getSearchConditonInfo();
    	if (Ext.isEmpty(rsl) || rsl.length < 3) {
			Ext.Msg.alert("提示", "请先增加查询条件");
			return;
		}
		
		var tableColumns = TABLECOLUMNS;

		if(Ext.isEmpty(tableColumns)){
			Ext.Msg.alert("提示","请先选择查询结果显示列");
			return;
		}
		
    	Ext.Ajax.request({
			url:'../AdvancedSearch/checkSearchParams.do',
            method:'POST',   
            params:{'searchCondition':rsl,'tables':baseTableData.toString(),'tableColums':tableColumns},
            success:function(response){
                var data = Ext.util.JSON.decode(response.responseText);
                if (data.success == true){
                	 msgPageJump("advSearch", "高级查询结果",'./pages/advancedSearch/searchResult.html?ssid=' + data.ssid);
                } else {
                    Ext.MessageBox.alert('警告',data.msg);
                } 
            },
            scope:this,
            failure:function(form,action){
	            Ext.MessageBox.alert('警告',action.result.msg);
	        }
        });
    }
    ,getSelectedTableColums:function(){
    	var tableColumns = "";
    	try{
			var tableArr = [];
			var form = this.tableFieldSelectorWin.items.itemAt(0).items.itemAt(0);
			var cks = form.findByType('checkbox');
	        for(var i=0;i<cks.length;i++){   
	         	var ck = cks[i];   
	           	if(ck.checked){   
		           	tableArr.push(ck.inputValue);
	            }   
	        } 
	        tableColumns = tableArr.toString();
		}catch (ex){
		}
		
		return tableColumns;
    }
    ,loadFinderData:function(id,text){
    	var grid = this;
    	
    	Ext.getCmp("searchNameId").setValue(text);
    	
    	/**
    	 * 加载查询条件
    	 */
    	Ext.Ajax.request({
			url:'../SearchCusCondition/extlistByUsercustomid.do',
            method:'POST',   
            params:{'id':id},
            success:function(response){
                var data = Ext.util.JSON.decode(response.responseText);
                grid.getStore().loadData(data,false);
            },
            scope:this,
            failure:function(form,action){
	            Ext.MessageBox.alert('警告',action.result.msg);
	        }
        });
        
        /**
         * 加载查询表和查询结果显示列
         */
    	Ext.Ajax.request({
			url:'../SearchCustoms/getSearchCustomsById.do',
            method:'POST',   
            params:{'id':id},
            success:function(response){
                var data = Ext.util.JSON.decode(response.responseText);
                var tablenames = data.tablenames;
                TABLECOLUMNS = data.tablecolumns;
                
                var tempTable = tablenames.split(",");
                
                /**获取主从表选择的组件*/
				var mainTableName = Ext.getCmp("mainTableNameId");
				var mainTableLabel = Ext.getCmp("mainTableLabelId");
				var minorTableName = Ext.getCmp("minorTableNameId");
				var minorTableLabel = Ext.getCmp("minorTableLabelId");
				
                if(tempTable.length == 4){
                	//初始化主从表数组
                	baseTableData = [["",""],["",""]];  
                	baseTableData[0][0] = tempTable[0];
                	baseTableData[0][1] = tempTable[1];
                	baseTableData[1][0] = tempTable[2];
                	baseTableData[1][1] = tempTable[3];
                	
                	//初始化从表是否可以选择
                	minorTableLabel.enable();  
					minorTableLabel.show();   			
					minorTableName.enable();  
					minorTableName.show();
					
					//初始化主从表内容
					mainTableName.setValue(tempTable[0]);
					mainTableName.setRawValue(tempTable[1]);
					minorTableName.setValue(tempTable[2]);
					minorTableName.setRawValue(tempTable[3]);
					
					minorTableName.getStore().baseParams['s_parentid'] = tempTable[0];
					
                } else if(tempTable.length == 2){
					//初始化主从表数组
                	baseTableData[0][0] = tempTable[0];
                	baseTableData[0][1] = tempTable[1];
                	
					//初始化主从表内容
					mainTableName.setValue(tempTable[0]);
					mainTableName.setRawValue(tempTable[1]);
					minorTableName.setValue("");
					minorTableName.setRawValue("");

					//初始化从表是否可以选择
                	minorTableLabel.disable();  
					minorTableLabel.hide();   			
					minorTableName.disable();  
					minorTableName.hide(); 
                }
                
                Ext.example.msg("提示","<b>" + text + "</b>搜索器加载成功！");
            },
            scope:this,  
            failure:function(form,action){
	            Ext.MessageBox.alert('警告',action.result.msg);
	        }
        });
    }
});

Ext.reg("advancedSearchEditorGrid",com.awd.advancedSearchEditorGrid);

com.awd.ssqtree = Ext.extend(Ext.tree.TreePanel, {
			initComponent : function() {
				Ext.apply(this, {
							title : '个人搜索器',
							rootVisible : false,
							lines : true,
							autoScroll : true,
							root : new Ext.tree.AsyncTreeNode({
										id : '0',
										text : 'root'
									}),
							loader : new Ext.tree.TreeLoader({
										dataUrl : '../SearchCustoms/extTrees.do'
									}),
							tbar : [{
									text : '刷新',
									cls : 'x-btn-text-icon',
									iconCls : 'refreshicon',
									handler : function() {
										this.root.reload();
									},scope:this
								}],
							collapseFirst : true
						});
				com.awd.ssqtree.superclass.initComponent.call(this);
				this.on('contextmenu',this.rightMenuAction); 
			}
			,rightMenuAction :function(node,event){   
				event.stopEvent();
				node.select();
				var rightMenu = new Ext.menu.Menu({  
				        id :'rightClickCont',  
				        items : [{  
				            text : '快速查询',
				            iconCls:'queryicon'
				            ,handler:this.fastSearch
				            ,scope:this  
				        }
				        ,{  
				            text : '删除',
				            iconCls:'deleteicon'
				           , handler:this.deleteFinder
				            ,scope:this  
				        }
				       ]  
				})
				
			    rightMenu.showAt(event.getXY());//取得鼠标点击坐标，展示菜单  
			    event.preventDefault();
		}
		,fastSearch:function(node){
			var selectedNode = this.getSelectionModel().getSelectedNode();
			var node = selectedNode.attributes;
			
	    	Ext.Ajax.request({
				url:'../AdvancedSearch/fastSearch.do',
	            method:'POST',   
	            params:{'id':node.id},
	            success:function(response){
	                var data = Ext.util.JSON.decode(response.responseText);
	                if (data.success == true){
	                	 msgPageJump("advSearch", "高级查询结果",'./pages/advancedSearch/searchResult.html?ssid=' + data.ssid);
	                } else {
	                    Ext.MessageBox.alert('警告',data.msg);
	                } 
	            },
	            scope:this,
	            failure:function(form,action){
		            Ext.MessageBox.alert('警告',action.result.msg);
		        }
	        });
			
		}
		,deleteFinder:function(){
			var selectedNode = this.getSelectionModel().getSelectedNode();
			var node = selectedNode.attributes;
			var tree = this;
	    	Ext.Ajax.request({
				url:'../SearchCustoms/extdelete.do',
	            method:'POST',   
	            params:{'ids':node.id},
	            success:function(response){
	               Ext.example.msg("提示","<b>" + node.text+"</b>搜索器删除成功！");
	               tree.root.reload();    
	            },
	            scope:this,
	            failure:function(form,action){
		            Ext.MessageBox.alert('警告',action.result.msg);
		        }
	        });
		}
		});
Ext.reg('ssqtree', com.awd.ssqtree);

com.awd.searchEditGridRelatedSsqGrid = Ext.extend(Ext.Panel, {
	layout : 'border',
	initComponent : function() {
		Ext.apply(this, {
					border : false,
					items : [{xtype:'ssqtree',border:false,region:'west',collapsible:true,split:true,width : 130}
							,{region:'center',xtype:"advancedSearchEditorGrid",title:"组合条件列表"}
					]
				});
		com.awd.searchEditGridRelatedSsqGrid.superclass.initComponent.apply(this, arguments);
		this.ssqtree = this.items.itemAt(0);
		this.mainGrid = this.items.itemAt(1);
		this.ssqtree.on({'click' : this.clickNode,scope : this});
        this.mainGrid.on({'reloadSsqTree':this.onReloadSsqTree,scope:this}); 
	},clickNode : function(node) {
		this.mainGrid.loadFinderData(node.id,node.text);
	}
	,onReloadSsqTree:function(){
		this.ssqtree.root.reload();
	}
});

Ext.reg('searchEditGridRelatedSsqGrid', com.awd.searchEditGridRelatedSsqGrid);

Ext.onReady(function(){
	var vp = new Ext.Viewport({
			layout:'fit',
			items:{xtype:'searchEditGridRelatedSsqGrid'}
	});
});
