Ext.namespace('com.awd');
Ext.namespace('com.awd.advancedSearch');

com.awd.advancedSearch.tableGroup = Ext.extend(Ext.form.FormPanel, {
	initComponent : function() {
		Ext.apply(this, {
			border : true,
			buttonAlign:'right',
			bodyStyle : 'padding:5px;overflow-y:scroll;border-left:1px solid #8DB2E3'
		});
		com.awd.advancedSearch.tableGroup.superclass.initComponent.apply(this,arguments);
	}
	,loadTableField:function(selectedTableColumns){
		   Ext.Ajax.request({
					url : '../AdvancedSearch/getDisplayTables.do',
					method:'post',
					params:{tableNames:baseTableData.toString()},
					success : function(request) {
						var tables = Ext.decode(request.responseText);
						var myfieldset = null;
						if (this.items.length == 0) {
							for (var i = 0; i < tables.length; i++) {
								myfieldset = new Ext.form.FieldSet({
									title : tables[i].tableString
									,collapsible : true
									,autoHeight : true
									,layout : 'column'
									,items : [
									   {xtype : 'remotecheckboxgroup',
										columns : 5,
										url : '../SearchTableColumns/extListAsFieldDisplay.do',
										baseParams : {
											dir : 'ASC',
											limit : '150',
											s_tablename : tables[i].tableName,
											selectedTableColumns:selectedTableColumns
										},
										reader : new Ext.data.JsonReader({
													totalProperty : 'totalProperty',
													root : 'list',
													fields : [{name : 'fieldId'},{name : 'fieldName'},{name : 'fieldLabel'},{name : 'fieldValue'},{name : 'fieldChecked'}]
												}),
										fieldId : 'fieldId',
										fieldName : 'fieldName',
										fieldLabel : 'fieldLabel',
										fieldValue : 'fieldValue',
										fieldChecked : 'fieldChecked'
									}]
								});
								this.items.add(myfieldset);
							}
						}else{
							for (var j = 0; j < tables.length; j++) {
								this.remove(0);  
							}
							for (var i = 0; i < tables.length; i++) {
								myfieldset = new Ext.form.FieldSet({
									title : tables[i].tableString
									,collapsible : true
									,autoHeight : true
									,layout : 'column'
									,items : [
									   {xtype : 'remotecheckboxgroup',
										columns : 5,
										url : '../SearchTableColumns/extListAsFieldDisplay.do',
										baseParams : {
											dir : 'ASC',
											limit : '150',
											s_tablename : tables[i].tableName,
											selectedTableColumns:selectedTableColumns
										},
										reader : new Ext.data.JsonReader({
													totalProperty : 'totalProperty',
													root : 'list',
													fields : [{name : 'fieldId'},{name : 'fieldName'},{name : 'fieldLabel'},{name : 'fieldValue'},{name : 'fieldChecked'}]
												}),
										fieldId : 'fieldId',
										fieldName : 'fieldName',
										fieldLabel : 'fieldLabel',
										fieldValue : 'fieldValue',
										fieldChecked : 'fieldChecked'
									}]
								});
								this.items.add(myfieldset);  
							}
						}
						this.doLayout(true);
					}
					,scope : this
					,failure : function() {
						alert('加载错误，请确认网络连接正常！');
					}
				});	
		}
});
Ext.reg('tableGroup', com.awd.advancedSearch.tableGroup);